package com.hai.dao;

import com.hai.entity.BsRechargeCode;
import com.hai.entity.BsRechargeCodeExample;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface BsRechargeCodeMapper extends BsRechargeCodeMapperExt {
    @SelectProvider(type=BsRechargeCodeSqlProvider.class, method="countByExample")
    long countByExample(BsRechargeCodeExample example);

    @DeleteProvider(type=BsRechargeCodeSqlProvider.class, method="deleteByExample")
    int deleteByExample(BsRechargeCodeExample example);

    @Delete({
        "delete from bs_recharge_code",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int deleteByPrimaryKey(Long id);

    @Insert({
        "insert into bs_recharge_code (`type`, source_id, ",
        "recharge_platform, goods_id, ",
        "operator_id, operator_name, ",
        "create_time, update_time, ",
        "`status`, ext_1, ext_2, ",
        "ext_3)",
        "values (#{type,jdbcType=INTEGER}, #{sourceId,jdbcType=VARCHAR}, ",
        "#{rechargePlatform,jdbcType=INTEGER}, #{goodsId,jdbcType=VARCHAR}, ",
        "#{operatorId,jdbcType=BIGINT}, #{operatorName,jdbcType=VARCHAR}, ",
        "#{createTime,jdbcType=TIMESTAMP}, #{updateTime,jdbcType=TIMESTAMP}, ",
        "#{status,jdbcType=INTEGER}, #{ext1,jdbcType=VARCHAR}, #{ext2,jdbcType=VARCHAR}, ",
        "#{ext3,jdbcType=VARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(BsRechargeCode record);

    @InsertProvider(type=BsRechargeCodeSqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(BsRechargeCode record);

    @SelectProvider(type=BsRechargeCodeSqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="type", property="type", jdbcType=JdbcType.INTEGER),
        @Result(column="source_id", property="sourceId", jdbcType=JdbcType.VARCHAR),
        @Result(column="recharge_platform", property="rechargePlatform", jdbcType=JdbcType.INTEGER),
        @Result(column="goods_id", property="goodsId", jdbcType=JdbcType.VARCHAR),
        @Result(column="operator_id", property="operatorId", jdbcType=JdbcType.BIGINT),
        @Result(column="operator_name", property="operatorName", jdbcType=JdbcType.VARCHAR),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<BsRechargeCode> selectByExample(BsRechargeCodeExample example);

    @Select({
        "select",
        "id, `type`, source_id, recharge_platform, goods_id, operator_id, operator_name, ",
        "create_time, update_time, `status`, ext_1, ext_2, ext_3",
        "from bs_recharge_code",
        "where id = #{id,jdbcType=BIGINT}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="type", property="type", jdbcType=JdbcType.INTEGER),
        @Result(column="source_id", property="sourceId", jdbcType=JdbcType.VARCHAR),
        @Result(column="recharge_platform", property="rechargePlatform", jdbcType=JdbcType.INTEGER),
        @Result(column="goods_id", property="goodsId", jdbcType=JdbcType.VARCHAR),
        @Result(column="operator_id", property="operatorId", jdbcType=JdbcType.BIGINT),
        @Result(column="operator_name", property="operatorName", jdbcType=JdbcType.VARCHAR),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="status", property="status", jdbcType=JdbcType.INTEGER),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    BsRechargeCode selectByPrimaryKey(Long id);

    @UpdateProvider(type=BsRechargeCodeSqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") BsRechargeCode record, @Param("example") BsRechargeCodeExample example);

    @UpdateProvider(type=BsRechargeCodeSqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") BsRechargeCode record, @Param("example") BsRechargeCodeExample example);

    @UpdateProvider(type=BsRechargeCodeSqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(BsRechargeCode record);

    @Update({
        "update bs_recharge_code",
        "set `type` = #{type,jdbcType=INTEGER},",
          "source_id = #{sourceId,jdbcType=VARCHAR},",
          "recharge_platform = #{rechargePlatform,jdbcType=INTEGER},",
          "goods_id = #{goodsId,jdbcType=VARCHAR},",
          "operator_id = #{operatorId,jdbcType=BIGINT},",
          "operator_name = #{operatorName,jdbcType=VARCHAR},",
          "create_time = #{createTime,jdbcType=TIMESTAMP},",
          "update_time = #{updateTime,jdbcType=TIMESTAMP},",
          "`status` = #{status,jdbcType=INTEGER},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR}",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int updateByPrimaryKey(BsRechargeCode record);
}