package com.hai.dao;

import com.hai.entity.GoodsShoppingCart;
import com.hai.entity.GoodsShoppingCartExample;
import java.util.List;
import org.apache.ibatis.annotations.Delete;
import org.apache.ibatis.annotations.DeleteProvider;
import org.apache.ibatis.annotations.Insert;
import org.apache.ibatis.annotations.InsertProvider;
import org.apache.ibatis.annotations.Options;
import org.apache.ibatis.annotations.Param;
import org.apache.ibatis.annotations.Result;
import org.apache.ibatis.annotations.Results;
import org.apache.ibatis.annotations.Select;
import org.apache.ibatis.annotations.SelectProvider;
import org.apache.ibatis.annotations.Update;
import org.apache.ibatis.annotations.UpdateProvider;
import org.apache.ibatis.type.JdbcType;
import org.springframework.stereotype.Repository;

/**
 * 
 * 代码由工具生成,请勿修改!!!
 * 如果需要扩展请在其父类进行扩展
 * 
 **/
@Repository
public interface GoodsShoppingCartMapper extends GoodsShoppingCartMapperExt {
    @SelectProvider(type=GoodsShoppingCartSqlProvider.class, method="countByExample")
    long countByExample(GoodsShoppingCartExample example);

    @DeleteProvider(type=GoodsShoppingCartSqlProvider.class, method="deleteByExample")
    int deleteByExample(GoodsShoppingCartExample example);

    @Delete({
        "delete from goods_shopping_cart",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int deleteByPrimaryKey(Long id);

    @Insert({
        "insert into goods_shopping_cart (goods_id, user_id, ",
        "title, img, sku, ",
        "num, price, original_price, ",
        "whether_check, lose_efficacy, ",
        "create_time, update_time, ",
        "op_id, op_name, ext_1, ",
        "ext_2, ext_3)",
        "values (#{goodsId,jdbcType=BIGINT}, #{userId,jdbcType=BIGINT}, ",
        "#{title,jdbcType=VARCHAR}, #{img,jdbcType=VARCHAR}, #{sku,jdbcType=VARCHAR}, ",
        "#{num,jdbcType=VARCHAR}, #{price,jdbcType=DECIMAL}, #{originalPrice,jdbcType=DECIMAL}, ",
        "#{whetherCheck,jdbcType=BIT}, #{loseEfficacy,jdbcType=BIT}, ",
        "#{createTime,jdbcType=TIMESTAMP}, #{updateTime,jdbcType=TIMESTAMP}, ",
        "#{opId,jdbcType=BIGINT}, #{opName,jdbcType=VARCHAR}, #{ext1,jdbcType=VARCHAR}, ",
        "#{ext2,jdbcType=VARCHAR}, #{ext3,jdbcType=VARCHAR})"
    })
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insert(GoodsShoppingCart record);

    @InsertProvider(type=GoodsShoppingCartSqlProvider.class, method="insertSelective")
    @Options(useGeneratedKeys=true,keyProperty="id")
    int insertSelective(GoodsShoppingCart record);

    @SelectProvider(type=GoodsShoppingCartSqlProvider.class, method="selectByExample")
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="goods_id", property="goodsId", jdbcType=JdbcType.BIGINT),
        @Result(column="user_id", property="userId", jdbcType=JdbcType.BIGINT),
        @Result(column="title", property="title", jdbcType=JdbcType.VARCHAR),
        @Result(column="img", property="img", jdbcType=JdbcType.VARCHAR),
        @Result(column="sku", property="sku", jdbcType=JdbcType.VARCHAR),
        @Result(column="num", property="num", jdbcType=JdbcType.VARCHAR),
        @Result(column="price", property="price", jdbcType=JdbcType.DECIMAL),
        @Result(column="original_price", property="originalPrice", jdbcType=JdbcType.DECIMAL),
        @Result(column="whether_check", property="whetherCheck", jdbcType=JdbcType.BIT),
        @Result(column="lose_efficacy", property="loseEfficacy", jdbcType=JdbcType.BIT),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="op_id", property="opId", jdbcType=JdbcType.BIGINT),
        @Result(column="op_name", property="opName", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    List<GoodsShoppingCart> selectByExample(GoodsShoppingCartExample example);

    @Select({
        "select",
        "id, goods_id, user_id, title, img, sku, num, price, original_price, whether_check, ",
        "lose_efficacy, create_time, update_time, op_id, op_name, ext_1, ext_2, ext_3",
        "from goods_shopping_cart",
        "where id = #{id,jdbcType=BIGINT}"
    })
    @Results({
        @Result(column="id", property="id", jdbcType=JdbcType.BIGINT, id=true),
        @Result(column="goods_id", property="goodsId", jdbcType=JdbcType.BIGINT),
        @Result(column="user_id", property="userId", jdbcType=JdbcType.BIGINT),
        @Result(column="title", property="title", jdbcType=JdbcType.VARCHAR),
        @Result(column="img", property="img", jdbcType=JdbcType.VARCHAR),
        @Result(column="sku", property="sku", jdbcType=JdbcType.VARCHAR),
        @Result(column="num", property="num", jdbcType=JdbcType.VARCHAR),
        @Result(column="price", property="price", jdbcType=JdbcType.DECIMAL),
        @Result(column="original_price", property="originalPrice", jdbcType=JdbcType.DECIMAL),
        @Result(column="whether_check", property="whetherCheck", jdbcType=JdbcType.BIT),
        @Result(column="lose_efficacy", property="loseEfficacy", jdbcType=JdbcType.BIT),
        @Result(column="create_time", property="createTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="update_time", property="updateTime", jdbcType=JdbcType.TIMESTAMP),
        @Result(column="op_id", property="opId", jdbcType=JdbcType.BIGINT),
        @Result(column="op_name", property="opName", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_1", property="ext1", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_2", property="ext2", jdbcType=JdbcType.VARCHAR),
        @Result(column="ext_3", property="ext3", jdbcType=JdbcType.VARCHAR)
    })
    GoodsShoppingCart selectByPrimaryKey(Long id);

    @UpdateProvider(type=GoodsShoppingCartSqlProvider.class, method="updateByExampleSelective")
    int updateByExampleSelective(@Param("record") GoodsShoppingCart record, @Param("example") GoodsShoppingCartExample example);

    @UpdateProvider(type=GoodsShoppingCartSqlProvider.class, method="updateByExample")
    int updateByExample(@Param("record") GoodsShoppingCart record, @Param("example") GoodsShoppingCartExample example);

    @UpdateProvider(type=GoodsShoppingCartSqlProvider.class, method="updateByPrimaryKeySelective")
    int updateByPrimaryKeySelective(GoodsShoppingCart record);

    @Update({
        "update goods_shopping_cart",
        "set goods_id = #{goodsId,jdbcType=BIGINT},",
          "user_id = #{userId,jdbcType=BIGINT},",
          "title = #{title,jdbcType=VARCHAR},",
          "img = #{img,jdbcType=VARCHAR},",
          "sku = #{sku,jdbcType=VARCHAR},",
          "num = #{num,jdbcType=VARCHAR},",
          "price = #{price,jdbcType=DECIMAL},",
          "original_price = #{originalPrice,jdbcType=DECIMAL},",
          "whether_check = #{whetherCheck,jdbcType=BIT},",
          "lose_efficacy = #{loseEfficacy,jdbcType=BIT},",
          "create_time = #{createTime,jdbcType=TIMESTAMP},",
          "update_time = #{updateTime,jdbcType=TIMESTAMP},",
          "op_id = #{opId,jdbcType=BIGINT},",
          "op_name = #{opName,jdbcType=VARCHAR},",
          "ext_1 = #{ext1,jdbcType=VARCHAR},",
          "ext_2 = #{ext2,jdbcType=VARCHAR},",
          "ext_3 = #{ext3,jdbcType=VARCHAR}",
        "where id = #{id,jdbcType=BIGINT}"
    })
    int updateByPrimaryKey(GoodsShoppingCart record);
}